package geniusweb.profile.utilityspace;

import static org.junit.Assert.assertEquals;

import java.io.IOException;
import java.net.URI;
import java.net.URISyntaxException;
import java.util.Arrays;
import java.util.List;

import org.junit.Before;
import org.junit.Test;

import com.fasterxml.jackson.core.JsonParseException;
import com.fasterxml.jackson.core.JsonProcessingException;
import com.fasterxml.jackson.databind.JsonMappingException;
import com.fasterxml.jackson.databind.ObjectMapper;

import geniusweb.references.ProfileRef;
import tudelft.utilities.junit.GeneralTests;

public class ProfileRefTest extends GeneralTests<ProfileRef> {

	private ProfileRef profile1, profile1a, profile2, profile3;
	private String asJson = "\"ws:localhost/profile1\"";

	@Before
	public void before() throws URISyntaxException {
		profile1 = new ProfileRef(new URI("ws:localhost/profile1"));
		profile1a = new ProfileRef(new URI("ws:localhost/profile1"));
		profile2 = new ProfileRef(new URI("ws:localhost/profile2"));
		profile3 = new ProfileRef(new URI("http:localhost/profile3"));

	}

	@Override
	public List<List<ProfileRef>> getGeneralTestData() {
		return Arrays.asList(Arrays.asList(profile1, profile1a),
				Arrays.asList(profile2), Arrays.asList(profile3));
	}

	@Override
	public List<String> getGeneralTestStrings() {
		return Arrays.asList("ProfileRef.*profile1.*", "ProfileRef.*profile2.*",
				"ProfileRef.*profile3.*");
	}

	@Test
	public void smokeTest() throws URISyntaxException {
		new ProfileRef(new URI("ws:localhost"));
	}

	@Test(expected = IllegalArgumentException.class)
	public void nullTest() throws URISyntaxException {
		new ProfileRef((URI) null);
	}

	@Test
	public void testSerialize() throws JsonProcessingException {
		ObjectMapper jackson = new ObjectMapper();

		String json = jackson.writeValueAsString(profile1);
		System.out.println(json);
		assertEquals(asJson, json);
	}

	@Test
	public void testDeserialize()
			throws JsonParseException, JsonMappingException, IOException {
		ObjectMapper jackson = new ObjectMapper();
		ProfileRef p = jackson.readValue(asJson, ProfileRef.class);
		System.out.println(p);
		assertEquals(profile1, p);
	}

}
